<template>
	<div :class="$style.formWrapper">
		<form
			:class="[$style.form, $style[`variation__${styleVariation}`]]"
			:style="{ '--form-max-width': maxWidth ? `${maxWidth / 10}rem` : '48rem' }"
			@submit.prevent="$emit('submit', data)"
		>
			<slot name="header" />

			<ul :class="$style.formList">
				<li
					v-for="field in spec.filter((field) =>
						typeof field.renderCondition === 'function' ? field.renderCondition(data, $route.path) : true
					)"
					:key="field.id"
					:class="[
						$style.row,
						$style[`__type-${field.type || 'text'}`],
						{ [$style[`__${field.appearance}`]]: field.appearance },
					]"
				>
					<div v-if="field.type === 'section-title'">
						<h3 :class="$style.sansSerif">{{ field.default }}</h3>
						<hr />
					</div>
					<span v-if="field.type === 'separator'" :class="$style.separator" />
					<template v-else>
						<p :class="$style.helperText">{{ field.helperText }}</p>
						<component :is="field.component" v-model="data[field.id]" v-bind="{ ...getPropsToBind(field) }" />
					</template>
				</li>
			</ul>

			<slot name="error" />

			<div :class="$style.ctaSection">
				<BaseButton type="submit" :is-working="isWorking" appearance="primary" size="medium">{{ ctaText }}</BaseButton>
			</div>

			<slot name="below-form" />
		</form>
	</div>
</template>

<script>
const notPropsToBind = ['component', 'id', 'appearance', 'default'];

export default {
	props: {
		spec: {
			type: Array,
			required: true,
		},

		isWorking: {
			type: Boolean,
			default: false,
		},

		styleVariation: {
			type: String,
			default: 'primary',
			validator: (v) => ['primary', 'secondary'].includes(v),
		},

		ctaText: {
			type: String,
			default: 'Submit',
		},

		maxWidth: {
			type: Number,
			default: null,
		},
	},

	data() {
		return {
			data: this.spec.reduce((final, field) => {
				if (field.id) {
					final[field.id] = field.default !== undefined ? field.default : '';
				}

				return final;
			}, {}),
		};
	},

	methods: {
		getPropsToBind(field) {
			return Object.entries(field)
				.filter(([key]) => !notPropsToBind.includes(key))
				.reduce(
					(final, [key, val]) => {
						final[key === 'displayLabel' ? 'label' : key] = val;

						return final;
					},
					{ type: 'text', labelFor: field.id }
				);
		},
	},
};
</script>

<style lang="scss" module>
@import '@design';

.formWrapper {
	hr {
		margin: size('m+') 0;
		border-top: 1px solid color('primary-500');
	}

	&.variation__secondary {
		background: color('primary-600');
	}
}

.form {
	max-width: var(--form-max-width);
	padding: 7.1rem 2.9rem 7.8rem;
	margin: 0 auto;
	line-height: 1.85714;

	p {
		@include use-text-style('type-100');

		font-weight: 300;
	}

	button {
		line-height: 1;
	}

	@include above('medium') {
		padding: 7.1rem 0 7.8rem;
	}
}

.formList {
	display: flex;
	flex-wrap: wrap;
	margin: size('m+') negative('m') / 2 0;
	list-style: none;

	label {
		padding-left: size('base');

		@include use-text-style('type-300');
	}
	select {
		line-height: 1;
		color: color('primary-250');

		option:first-child {
			color: color('primary-250');
		}
	}

	input {
		color: color('primary-250');
	}

	.variation__secondary & {
		margin: 4.3rem -0.8rem 0;

		input,
		input::placeholder,
		select {
			color: color('primary-250');
			opacity: 1;
		}

		input[type='text'],
		input[type='email'],
		input[type='tel'],
		textarea,
		select {
			@include use-text-style('type-100');

			padding: 1.16em 1.45em;
			border-color: color('primary-250');
			border-radius: 0.5rem;
		}

		select {
			padding: 1.16em 1.2em;
			background-position: 96.6% 50%;
			background-size: 3.9rem;
		}
	}
}

.row {
	flex: 0 0 auto;
	width: 100%;
	padding: 0 size('s++') / 2;
	margin-bottom: size('m+');

	&.__halfOnDesktop {
		@include above('medium') {
			width: 50%;
		}
	}

	&.__type-textarea {
		textarea {
			height: 16rem;
			color: color('primary-250');
		}
	}

	h4 {
		margin-bottom: size('m+');
		font-weight: normal;

		@include use-text-style('heading-180');
		@include font-family('secondary');
	}

	.quantityGroup {
		border-bottom: 1px solid color('primary-250');
	}
	.flex {
		display: flex;
		align-items: flex-end;
		justify-content: space-between;

		.quantityImg {
			min-width: 12.6rem;
			text-align: center;
		}

		img {
			max-width: 12.6rem;
			max-height: 12.4rem;
		}
	}

	.quantity {
		display: flex;
		align-items: center;
		justify-content: flex-end;
		margin-bottom: 1em;
		font-weight: 300;

		@include use-text-style('type-100');

		input {
			width: 5rem;
			height: 5rem;
			padding: 0;
			margin-left: size('s+');
			text-align: center;
		}
	}

	.variation__secondary & {
		padding: 0 0.9rem;
		margin: 0 0 2rem;

		&.__type-checkbox {
			margin: 1.5rem 0 0;

			&:last-of-type {
				margin: 1.5rem 0 2rem;
			}
		}
	}
}

.helperText {
	@include use-text-style('type-500');

	margin: 0 0 0.5em;
	font-weight: 400;
}

.ctaSection {
	text-align: center;

	.variation__primary & {
		margin: size('m++') 0;
	}
}

.sansSerif {
	font-weight: 300;
	text-align: center;

	@include use-text-style('type-500');
}

.separator {
	display: block;
	width: 100%;
	height: 1px;
	background: color('primary-250');
}
</style>
